/**
 * 제작 : emirue, emirue@adain.kr
 * 날짜 : 2017. 7. 4.
 * 내용 :
 */

import React from 'react';
import _ from 'lodash';
import {MdUnfoldMore, MdArrowDropUp, MdArrowDropDown} from 'react-icons/lib/md';

class AdainTreeHeader extends React.Component {
	constructor(props) {
		super(props);

		const {
			header
		} = props;

		this.state = {
			header
		};
		
		this.sortHeaderState = '';
		
		this.handleClick = this.handleClick.bind(this);
	}

	render() {
		const { header } = this.state;

		return (
			<div className="treeHeader">
				<div className="treeHeaderRowNbsp" />
				<div className="treeHeaderRow">
					{header.map((row, index) =>
						this.renderRow(row, index)
					)}
				</div>
			</div>
		);
	}

	renderRow(row, index) {
		return (
			<div className={row.className}
					 style={{width: row.width ? row.width : ''}}
					 onClick={() =>
							 this.handleClick(row, index)} key={index}>{row.title} {row.hasSort && (_.isEmpty(this.sortHeaderState) ? <MdUnfoldMore /> : this.sortHeaderState === 'asc' ? <MdArrowDropUp /> : <MdArrowDropDown />)}
			</div>
		);
	}

	handleClick(row, index) {
		if(!row.hasSort) return false;
		
		const {
			onHeaderClick
		} = this.props;

		let sortHeader = (_.isEmpty(this.sortHeaderState)) ? 'asc' : this.sortHeaderState;
		this.sortHeaderState = sortHeader === 'asc' ? 'desc' : 'asc';

		onHeaderClick({row, index, sortHeader: this.sortHeaderState});
	}
}

export default AdainTreeHeader;
